/* This is a quick Rexx hack to invoke the SWISH search engine from.          */
/* a CGI script using IBM's Internet Connection WWW server.                   */
/*                                                                            */
/* 3/20/1996, Kevin Vigor.                                                    */

/* Variables you will probably need to alter. */
TEMPDIR = 'D:\WWW\CGI-BIN\TEMP'     /* A temp directory writable by CGI files.*/
INDEX = 'D:\WWW\ETC\index.Swish'    /* The SWISH index to search.             */

/* Load Rexx utility functions. */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/* Write the MIME header required by CGI scripts. */
"@cgiutils -status 200 -ct text/html"

/* Title the results. */
say "<TITLE>Search results</TITLE>"

/* Begin the result body.*/
say "<BODY>"

/* Create a pair of temporary files. */
TEMPCMD = SysTempFileName(TEMPDIR'\ST$?????.CMD')
TEMPOUT = SysTempFileName(TEMPDIR'\ST$?????.OUT')

/* Write the call to SWISH to a temporary .CMD file.                */
/* Modify parameters to specify the proper index file if needed.    */
call charout TEMPCMD, '@swish -f 'INDEX' -w '
call STREAM TEMPCMD, 'c', 'CLOSE'

/* Add the parameters passed in from the Web server to the SWISH command line.*/
"@cgiparse -value SearchStr >>"TEMPCMD

/* Call the temp .CMD file we just generated with output sent to */
/* another temp file. */
"@call "TEMPCMD "> "TEMPOUT

/* Now delete the temp .CMD file we built. */
"@del "TEMPCMD" >NUL"

/* Parse the results of the search (now in TEMPOUT) */
/* Open it up. */
OPVAL=STREAM(TEMPOUT, 'C', 'open read')

/* If we failed to open the file, life really sucks.  */
if OPVAL <> 'READY:' THEN SIGNAL ErrorExit

ReadLoop:
/* Read the next line. */
RLINE = LINEIN(TEMPOUT)

/* The file ends with a single period, but also check for EOF. */
IF RLINE = '' THEN SIGNAL CleanExit
IF RLINE = '.' THEN SIGNAL CleanExit

/* Skip comment lines and empty lines. */
IF SUBSTR(RLINE, 1, 1, '#') = '#' THEN SIGNAL ReadLoop

/* Split the line into fields. */
PARSE VAR RLINE R_SCORE R_FILE R_TITLE R_POSITION

/* Make sure this looks valid (i.e. that position and score are both */
/* numeric variables).                                               */
IF VERIFY(R_SCORE, '1234567890') <> 0 THEN signal NoParse
IF VERIFY(R_POSITION, '1234567890') <> 0 THEN signal NoParse

/* Spit out this reference as a HTML link. */
say "<A HREF=/"TRANSLATE(R_FILE, '/', '\')">"R_TITLE" ("R_SCORE")</A><p>"

signal ReadLoop

NoParse:
/* This line is not a file hit; output it with no parsing (this handles */
/* error messages and status information).                              */
say RLINE"<p>"
signal ReadLoop

ErrorExit:
say "Error parsing search results."
signal Exit

CleanExit:
OPVAL=STREAM(TEMPOUT,'C','Close')

Exit:
/* delete the temp output file. */
"@del "TEMPOUT" >NUL"

/* End the output. */
say "</BODY>"

/* We're done. */
return 0
